/*
 * sxgraph.h X68k SX_SYSTEM ver 2.01 Copyright 1994 SHARP/First Class Technology
 */
#ifndef __SXGRAPH_H
#define __SXGRAPH_H

#ifndef __SXDEF2_H
#include <sxdef2.h>
#endif

#ifdef FORWORD
#define __PROTO_TYPE
#endif
#ifdef __STDC__
#define __PROTO_TYPE
#endif

typedef enum TextColor	TextColor;	/* eLXgJ[		*/
typedef enum CapKind	CapKind;	/* [̎		*/
typedef enum JoinKind	JoinKind;	/* ̎		*/
typedef enum ScreenType	ScreenType;	/* XN[^Cv		*/
typedef enum FontKind	FontKind;	/* tHgJCh		*/
typedef enum FontTbl	FontTbl;	/* ROMtHge[u		*/
typedef enum GScriptCommand GScriptCommand; /* OtXNvgR}h	*/
typedef enum GProc	GProc;		/* `惋[`e[u		*/
typedef enum RgnProc	RgnProc;	/* [WPsZ[`e[u */
typedef enum HProc	HProc;		/* `揉[`e[u */
typedef enum FontProc	FontProc;	/* `惋[`e[u	*/
typedef enum FontProcCommand FontProcCommand; /* tHg`R}h	*/

typedef struct Polygon	Polygon;	/* |SR[h		*/
typedef Polygon		***NPoly;	/* j[|S		*/
typedef struct NPolyEnv	NPolyEnv;	/* |SR[h		*/
typedef struct RectImg	RectImg;	/* N^OC[W		*/
typedef struct Bits	Bits;		/* rbcR[h		*/
typedef struct Pen	Pen;		/* y񃌃R[h		*/
typedef struct TX16	TX16;		/* G16C[WR[h		*/
typedef struct GSOneEnv	GSOneEnv;	/* OtXNvg`R[h */
typedef struct SpltBz	SpltBz;		/* xWFȐ񃌃R[h	*/
typedef struct SpltBSp	SpltBSp;	/* aXvCȐ񃌃R[h */
typedef struct FontList	FontList;	/* tHgXg		*/
/*
 *	Ot}iGraph Manj
 */
enum TextColor {			/* eLXgJ[		*/
	G_THRU,				/* iOtBbNʂ
					   j			*/
	G_WHITE		=  8,		/* 				*/
	G_LGRAY,			/* 邢O[			*/
	G_DGRAY,			/* ÂO[			*/
	G_BLACK,			/* 				*/
	G_YELLOW,			/* F				*/
	G_RED,				/* 				*/
	G_GREEN,			/* 				*/
	G_BLUE				/* 				*/
};

enum CapKind {				/* [̎		*/
	G_BUTTCAP,			/* obg[			*/
	G_ROUNDCAP,			/* ی^[			*/
	G_PROJECTCAP			/* ˏo[			*/
};

enum JoinKind {				/* ̎		*/
	G_MITERJOIN,			/* }C^[			*/
	G_ROUNDJOIN,			/* Eh			*/
	G_BEVELJOIN			/* xx			*/
};

enum ScreenType {			/* XN[^Cv		*/
	G_TXT,				/* eLXg^Cv		*/
	G_GRP,				/* OtBbN^Cv		*/
	G_GR2,				/* GR2^Cv			*/
	G_GR3				/* GR3^Cv			*/
};

/* x[XAhX */
#define G_TXTBASE	((char *) 0xe00000) /* eLXg^Cv̏ꍇ	*/
#define G_GRPBASE	((char *) 0xc00000) /* OtBbN^Cv̏ꍇ	*/

/* PC̃oCg */
#define G_TXTLINE	128		/* eLXg^Cv̏ꍇ		*/
#define G_GRPLINE	2048		/* OtBbN^Cv̏ꍇ	*/

/* Py[W̃oCg */
#define G_TXTPAGE	0x20000		/* eLXg^Cv̏ꍇ		*/

/* ANZXy[W */
#define G_PAGE0		1		/* y[WO			*/
#define G_PAGE1		(1 << 1)	/* y[WP			*/
#define G_PAGE2		(1 << 2)	/* y[WQ			*/
#define G_PAGE3		(1 << 3)	/* y[WR			*/
#define G_ALLPAGE	0x0f		/* Sy[W			*/

/* uhEFCgVI */
#define G_GRPRATIO	0x8000		/* OtBbN^Cv
					   65536FF\ȏꍇ	*/

enum PenModeHi {			/* y[h̏ʃoCg	*/
	G_FORE,				/* tHAOEhJ[	*/
	G_BACK,				/* obNOEhJ[	*/
	G_PPAT,				/* yp^[			*/
	G_EXPAT				/* GNXehp^[		*/
};

enum PenModeLow {			/* y[h̉ʃoCg */
	G_PSET,				/* PSET			*/
	G_AND,				/* AND			*/
	G_OR,				/* OR			*/
	G_XOR,				/* XOR			*/
	G_NPSET,			/* NOT PSET		*/
	G_NAND,				/* NOT AND		*/
	G_NOR,				/* NOT OR		*/
	G_NXOR,				/* NOT XOR		*/
	G_ADD,				/* ADD			*/
	G_ADDLIM,			/* ADD LIMIT		*/
	G_SUB,				/* SUB			*/
	G_SUBLIM,			/* SUB LIMIT		*/
	G_SELMAX,			/* SELECT MAX		*/
	G_SELMIN,			/* SELECT MIN		*/
	G_BLEND		/* 14 */	/* BLEND		*/
};

enum FontKind {				/* tHgJCh	*/
	G_ROM12,			/* ROM12hbg		*/
	G_ROM16,			/* ROM16hbg		*/
	G_ROM24,			/* ROM24hbg		*/
	G_TRAD		= 128,		/* Trad			*/
	G_AMADEUS,			/* Amadeus		*/
	G_ARTIST,			/* Artist		*/
	G_BAROQUE,			/* Baroque		*/
	G_COMP,				/* Comp			*/
	G_HOUSE,			/* House		*/
	G_JACK,				/* Jack			*/
	G_NABLA,			/* Nabla		*/
	G_PANK,				/* Pank			*/
	G_SMART,			/* Smart		*/
	G_MG1R		= 531,		/* ۃSVbŃi׎j	*/
	G_MG4R		= 534,		/* ۃSVbŃij	*/
	G_MG7R		= 537,		/* ۃSVbŃij	*/
	G_KG1S		= 561,		/* pSVbŃi׎j	*/
	G_KG4S		= 564,		/* pSVbŃij	*/
	G_KG7S		= 567		/* pSVbŃij	*/
};

/* tHgtFCX */
#define G_PLANE		0		/* W			*/
#define G_BOLD		1		/* 			*/
#define G_ITALIC	(1 << 1)	/* C^bN		*/
#define G_ULINE		(1 << 2)	/* A_[C	*/
#define G_OLINE		(1 << 3)	/* 		*/
#define G_SHADOW	(1 << 4)	/* et		*/
#define G_KERNING	(1 << 5)	/* J[jO		*/

enum FontTbl {				/* ROMtHge[u		*/
	GF_HA12,			/* 12hbgp		*/
	GF_ZS12,			/* 12hbgSp		*/
	GF_HA16,			/* 16hbgp		*/
	GF_HG16,			/* 16hbgpO		*/
	GF_QU16,			/* 16hbg1/4pt	*/
	GF_QL16,			/* 16hbg1/4pt	*/
	GF_QM16,			/* 16hbg1/4p		*/
	GF_ZA16,			/* 16hbgSp񊿎		*/
	GF_Z116,			/* 16hbgSpJISP	*/
	GF_Z216,			/* 16hbgSpJISQ	*/
	GF_ZG16,			/* 16hbgSpO		*/
	GF_ZS16,			/* 16hbgSp		*/
	GF_HA24,			/* 24hbgp		*/
	GF_HG24,			/* 24hbgpO		*/
	GF_QU24,			/* 24hbg1/4pt	*/
	GF_QL24,			/* 24hbg1/4pt	*/
	GF_QM24,			/* 24hbg1/4p		*/
	GF_ZA24,			/* 24hbgSp񊿎		*/
	GF_Z124,			/* 24hbgSpJISP	*/
	GF_Z224,			/* 24hbgSpJISQ	*/
	GF_ZG24,			/* 24hbgSpO		*/
	GF_ZS24		/* 21 */	/* 24hbgSp		*/
};

enum GScriptCommand {			/* OtXNvgR}h	*/
	GS_END		= -1,		/* R}h̏I		*/
	GS_NOP,				/* sȂ			*/
	GS_REM,				/* 				*/
	GS_BITMAP,			/* rbg}bv̐ݒ		*/
	GS_APAGE,			/* ANZXy[W̐ݒ		*/
	GS_CLIP,			/* Nbv[W̕ύX	*/
	GS_PMODE,			/* y[h̎w		*/
	GS_PSIZE,			/* yTCY̎w		*/
	GS_FKIND,			/* tHgJCh̎w	*/
	GS_FFACE,			/* tHgtFCX̎w	*/
	GS_FMODE,			/* tHg[h̎w		*/
	GS_FSIZE,			/* tHgTCY̎w		*/
	GS_FORE,			/* tHAOEhJ[̎w	*/
	GS_BACK,			/* obNOEhJ[̎w	*/
	GS_PPAT,			/* yp^[̎w		*/
	GS_EXPAT,			/* GNXehp^[̎w	*/
	GS_LINE,			/* C̕`			*/
	GS_FRRECT,			/* N^O̕`		*/
	GS_FLRECT,			/* N^O̓hԂ	*/
	GS_FRRRECT,			/* EhN^O̕`	*/
	GS_FLRRECT,			/* EhN^O̓hԂ */
	GS_FROVAL,			/* I[o̕`		*/
	GS_FLOVAL,			/* I[o̓hԂ		*/
	GS_FRARC,			/* A[N̕`			*/
	GS_FLARC,			/* A[N̓hԂ		*/
	GS_FRPOLY,			/* |S̕`		*/
	GS_FLPOLY,			/* |S̓hԂ		*/
	GS_FRRGN,			/* [W̕`		*/
	GS_FLRGN,			/* [W̓hԂ	*/
	GS_STR,				/* ̕`			*/
	GS_PUT,				/* rbgC[W̊g^k	*/
	GS_COPY,			/* rbgC[W̃Rs[	*/
	GS_FRNPOLY,			/* j[|S̕`		*/
	GS_FLNPOLY	/* 32 */	/* j[|S̓hԂ	*/
};

enum GProc {				/* `惋[`e[u		*/
	G_STR,				/* ̕`			*/
	G_LINE,				/* C̕`			*/
	G_RECT,				/* N^O̕`		*/
	G_RRECT,			/* EhN^O̕`	*/
	G_OVAL,				/* I[o̕`		*/
	G_ARC,				/* A[N̕`			*/
	G_POLY,				/* |S̕`		*/
	G_RGN,				/* [W̕`		*/
	G_COPY,				/* rbgC[W̃Rs[	*/
	G_RSV1,				/* VXe\			*/
	G_RSV2,				/* VXe\			*/
	G_WIDTH,			/* ̕߂		*/
	G_LENGTH,			/* w肵Ɏ܂镶̒
					   ߂			*/
	G_NPOLY,			/* j[|S̕`		*/
	G_BEZIER,			/* xWFȐ̕`		*/
	G_BSPLINE	/* 15 */	/* BXvCȐ̕`	*/
};

enum RgnProc {				/* [WPsZ[`e[u */
	GR_AND,				/* 1CANDƂ		*/
	GR_OR,				/* 1CORƂ		*/
	GR_DIFF,			/* 1C̍Ƃ		*/
	GR_XOR				/* 1CXORƂ		*/
};

enum HProc {				/* `揉[`e[u */
	GH_LINE,			/* C`̂߂̏	*/
	GH_COPY,			/* CRs[̂߂̏ */
	GH_PUT				/* rbgC[W`̂߂̏ */
};

enum FontProc {				/* `惋[`e[u	*/
	GF_FACE,			/* 蕶			*/
	GF_PUTCHAR			/* rbgC[W̕`		*/
};

enum PlotMode {				/* vbg[h		*/
	G_STD,				/* W				*/
	G_REV,				/* ]				*/
	G_HILITE,			/* nCCg			*/
	G_HILREV,			/* nCCg]		*/
	G_ERACE,			/* 				*/
	G_MESH		= 6,		/* Ԋ|			*/
	G_MESREV,			/* Ԋ|]			*/
	G_HIDDEN,			/* s			*/
	G_HIDREV			/* s]			*/
};

enum CRTMode {			/* ʃ[h				*/
	G_WS3H,			/* 1024~1024A16FA512~512A𑜓x	*/
	G_WS3L,			/* 1024~1024A16FA512~512AW𑜓x */
	G_WS0H,			/* 1024~1024A16FA256~256A𑜓x	*/
	G_WS0L,			/* 1024~1024A16FA256~256AW𑜓x */
	G_NS3H,			/* 512~512A16FA512~512A𑜓x	*/
	G_NS3L,			/* 512~512A16FA512~512AW𑜓x	*/
	G_NS0H,			/* 512~512A16FA256~256A𑜓x	*/
	G_NS0L,			/* 512~512A16FA256~256AW𑜓x	*/
	G_NM3H,			/* 512~512A256FA512~512A𑜓x	*/
	G_NM3L,			/* 512~512A256FA512~512AW𑜓x */
	G_NM0H,			/* 512~512A256FA256~256A𑜓x	*/
	G_NM0L,			/* 512~512A256FA256~256AW𑜓x */
	G_NL3H,			/* 512~512A65536FA512~512A𑜓x */
	G_NL3L,			/* 512~512A65536FA512~512AW𑜓x */
	G_NL0H,			/* 512~512A65536FA256~256A𑜓x */
	G_NL0L,			/* 512~512A65536FA256~256AW𑜓x */
	G_WS4H,		/* 16      1024~1024A16FA768~512A𑜓x	*/
	G_WS7V		=  19	/* 1024~1024A16FA640~480AVGAj^ */
};

enum CharKind {				/* R[h			*/
	G_HANK,				/* p			*/
	G_HGAI,				/* pO			*/
	G_QUANK,			/* 1/4pt		*/
	G_QLANK,			/* 1/4pt		*/
	G_ZANK		= 5,		/* Sp񊿎			*/
	G_ZJIS1,			/* SpJISP		*/
	G_ZJIS2,			/* SpJISQ		*/
	G_ZGAI,				/* SpO			*/
	G_ZSPC				/* Sp			*/
};

struct Polygon {			/* |SR[h		*/
	long size;			/* R[hŜ̃TCY		*/
	Rect bounds;			/* oEhN^O		*/
	LPoint pt[_VARLEN];		/* _̃|Cgziϒf[^j*/
};

struct NPolyEnv {			/* |SR[h		*/
	long lineWidth;			/* ̑			*/
	CapKind capKind;		/* [̎		*/
	JoinKind joinKind;		/* ̎		*/
	long miterLimit;		/* }C^[~bg		*/
};

struct RectImg {			/* N^OC[W		*/
	Rect bounds;			/* oEhN^O		*/
	BitImg data[_VARLEN];		/* rbgC[Wiϒf[^j*/
};

struct GScript {			/* OtXNvgR[h	*/
	long size;			/* R[hŜ̃TCY		*/
	unsigned short version;		/* OtXNvg̃o[W	*/
	Region clipping;		/* OtXNvg̊O`\
					   [Wiϒf[^j	*/
/*	short command[_VARLEN];		/* OtXNvgR}h
					   iϒf[^j		*/
};

struct Bits {				/* rbcR[h		*/
	Bitmap bmap;			/* rbg}bvR[h		*/
	long size;			/* C[W̃oCg		*/
	short lockLvl;			/* bNx			*/
	char rsv[16];			/* VXe\			*/
	unsigned char data[_VARLEN];	/* rbgC[Wiϒf[^j*/
};

struct Pen {				/* y񃌃R[h		*/
	Point loc;			/* yʒu			*/
	Point size;			/* yTCY			*/
	unsigned short mode;		/* y[h			*/
	BitImg *pat;			/* yp^[			*/
};

struct TX16 {				/* G16C[WR[h		*/
	unsigned long self;		/* 'TX16'			*/
	long size;			/* ȍ~̃oCg		*/
	Rect bounds;			/* oEhN^O		*/
	unsigned short palet[16];	/* 16F̃pbgl		*/
	unsigned char data[_VARLEN];	/* C[Wf[^iϒf[^j */
};

struct GSOneEnv {			/* OtXNvg`R[h */
	GScript **gScript;		/* OtXNvgnh	*/
	long offset;			/* 擪̃ItZbg		*/
	Rect source;			/* ÕN^O		*/
	Rect dest;			/* `sN^O	*/
	Graph *graph;			/* Ot|C^		*/
};

struct SpltBz {				/* xWFȐ񃌃R[h	*/
	Point a1;			/* N_̍W			*/
	Point c1;			/* _P̍W		*/
	Point c2;			/* _Q̍W		*/
	Point a2;			/* _̍W			*/
	Point c3;			/* _R̍W		*/
	Point c4;			/* _S̍W		*/
	Point a3;			/* I_̍W			*/
};

struct SpltBSp {			/* aXvCȐ񃌃R[h */
	Point a1;			/* N_̍W			*/
	Point c1;			/* ԓ_P̍W		*/
	Point a2;			/* _̍W			*/
	Point c2;			/* ԓ_Q̍W		*/
	Point a3;			/* I_̍W			*/
};
/*
 *	tHg} (Font Man)
 */
enum FontProcCommand {			/* tHg`R}h		*/
	FP_INIT,			/* `p[N̏	*/
	FP_TINI,			/* tHg̉		*/
	FP_INFO,			/* P̕ƍ̍ől߂ */
	FP_DRAW,			/* tHg̕`		*/
	FP_LENGTH,			/* w肵Ɏ܂镶̒
					   ߂			*/
	FP_WIDTH,			/* ̕߂		*/
	FP_REV,				/* tHg̖߂蕝̎擾	*/
	FP_RSV,				/* VXe\			*/
	FP_MAX		= 7
};

struct FontList {			/* tHgXg		*/
	short ID;			/* tHghc			*/
	short type;			/* tHg^Cv		*/
	short motherID;			/* }U[hc			*/
	char name[26];			/* tHg			*/
};

#ifdef __PROTO_TYPE
/*
 *	Ot}iGraph Manj
 */
int GMOpenGraph(int, Graph *);
int GMCloseGraph(Graph *);
int GMInitGraph(Graph *);
int GMSetGraph(Graph *);
Graph *GMGetGraph(void);
int GMCopyGraph(Graph *, Graph *);
void GMMoveGraph(LPoint);
void GMSlideGraph(LPoint);
int GMSetClip(Region **);
int GMGetClip(Region **);
int GMClipRect(Rect *);
int GMSetHome(LPoint);
int GMSetGraphSize(LPoint);
int GMSetBitmap(Bitmap *);
LPoint GMLocalToGlobal(LPoint);
LPoint GMGlobalToLocal(LPoint);
void GMInitPen(void);
BOOLEAN GMPenShow(void);
BOOLEAN GMPenHide(void);
LPoint GMPenSize(LPoint);
int GMPenMode(int);
BitImg *GMPenPat(BitImg *);
BitImg *GMExPat(BitImg *);
int GMForeColor(int);
int GMBackColor(int);
int GMAPage(int);
LPoint GMGetLoc(void);
void GMGetPen(Pen *);
void GMSetPen(Pen *);
void GMInitialize(void);
void GMNullRect(Rect *);
int GMSizeRect(Rect *, LPoint);
int GMAndRects(int, Rect *, Rect *, Rect *, ...);
int GMMoveRect(Rect *, LPoint);
int GMSlideRect(Rect *, LPoint);
int GMInsetRect(Rect *, LPoint);
int GMAndRect(Rect *, Rect *, Rect *);
int GMOrRect(Rect *, Rect *, Rect *);
BOOLEAN GMPtInRect(Rect *, LPoint);
BOOLEAN GMEqualRect(Rect *, Rect *);
BOOLEAN GMEmptyRect(Rect *);
int GMAdjustRect(Rect *, Rect *, Rect *);
Region **GMNewRgn(void);
int GMDisposeRgn(Region **);
int GMOpenRgn(void);
int GMCloseRgn(Region **);
int GMNullRgn(Region **);
int GMRectRgn(Region **, Rect *);
int GMCopyRgn(Region **, Region **);
int GMMoveRgn(Region **, LPoint);
int GMSlideRgn(Region **, LPoint);
int GMInsetRgn(Region **, LPoint);
int GMAndRgn(Region **, Region **, Region **);
int GMOrRgn(Region **, Region **, Region **);
int GMDiffRgn(Region **, Region **, Region **);
int GMXorRgn(Region **, Region **, Region **);
int GMPtInRgn(Region **, LPoint);
int GMRectInRgn(Region **, Rect *);
int GMEqualRgn(Region **, Region **);
int GMEmptyRgn(Region **);
int GMImgToRgn(Region **, Bitmap *, Rect *);
int GMInitBitmap(int, Bitmap *);
void GMMove(LPoint);
void GMMoveRel(LPoint);
int GMLine(LPoint);
int GMLineRel(LPoint);
int GMFrameRect(Rect *);
int GMFillRect(Rect *);
int GMFrameOval(Rect *);
int GMFillOval(Rect *);
int GMFrameRRect(Rect *, LPoint);
int GMFillRRect(Rect *, LPoint);
int GMFrameArc(Rect *, int, int);
int GMFillArc(Rect *, int, int);
int GMFrameRgn(Region **);
int GMFillRgn(Region **);
int GMFramePoly(Polygon **);
int GMFillPoly(Polygon **);
int GMScroll(Rect *, LPoint, Region **);
int GMCopy(Bitmap *, Bitmap *, Rect *, Rect *, int, Region **);
int GMCopyMask(Bitmap *, Bitmap *, Bitmap *, Rect *, LPoint, Rect *);
int GMPlotImg(BitImg *, Rect *, int);
int GMPutRImg(RectImg *, LPoint);
int GMDupHImg(BitImg *, LPoint, int, int);
int GMDupVImg(BitImg *, LPoint, int, int);
int GMDupHRImg(RectImg *, LPoint, int);
int GMDupVRImg(RectImg *, LPoint, int);
int GMFontKind(int);
int GMFontFace(int);
int GMFontMode(int);
LPoint GMFontSize(LPoint);
int GMDrawChar(int);
int GMDrawStrL(const _LASCII);
int GMDrawStr(const char *, long, int);
int GMDrawStrZ(const char *);
long GMCharWidth(int);
long GMStrLWidth(const _LASCII);
long GMStrWidth(const char *, long, int);
int GMStrLength(const char *, long, int);
LPoint GMFontInfo(void);
int GMOpenScript(Region **);
int GMCloseScript(GScript **);
int GMDisposeScript(GScript **);
int GMDrawScript(GScript **, Rect *);
long GMGetScript(GScript **, long);
int GMOpenPoly(void);
int GMClosePoly(Polygon **);
int GMDisposePoly(Polygon **);
int GMShadowStrZ(const char *, LPoint);
int GMShadowRect(Rect *);
int GMInvertRect(Rect *, int);
int GMInvertBits(LPoint, Bitmap *);
LPoint GMMapPt(LPoint, Rect *, Rect *);
void GMMapRect(Rect *, Rect *, Rect *);
void GMMapPoly(Polygon **, Rect *, Rect *);
void GMMapRgn(Region **, Rect *, Rect *);
LPoint GMScalePt(LPoint, Rect *, Rect *);
void GMInitPalet(void);
void GMDrawG16(TX16 *, LPoint);
int GMGetPixel(Bitmap *, LPoint);
int GMCalcMask(BitImg *, BitImg *, int, int, int, int);
int GMCalcFrame(BitImg *, BitImg *, int, int, int, int);
void *SXLongMul(void *, long, long);
int SXFixRound(long);
long SXFixMul(long, long);
long SXFixDiv(int, int);
unsigned char ***GMGetFontTable(void);
void GMCopyStdProc(int (**)());
long GMStrZWidth(const char *);
int GMTransImg(Bitmap *, Bitmap *, Rect *, Rect *);
int GMFillRImg(RectImg *, LPoint);
int GMFillImg(BitImg *, Rect *);
int GMSlidedRgn(Region **, Region **, LPoint);
int GMPaintRgn(Region **, Bitmap *, LPoint);
int GMSetRgnLine(int);
int GMGetRgnLine(void);
int GMInitGraphMode(int);
int GMCurFont(void);
LPoint GMGetScrnSize(void);
Graph *GMExgGraph(Graph *);
Bitmap *GMExgBitmap(Bitmap *);
Bitmap *GMGetBitmap(void);
int GMCalcBitmap(Bitmap *);
long GMCalcScrnSize(Bitmap *);
Bits **GMNewBits(int, Rect *, int);
void GMDisposeBits(Bits **);
int GMLockBits(Bits **);
int GMUnlockBits(Bits **);
int GMItalicRect(Rect *);
int GMItalicRgn(Region **, Rect *);
void GMFreeBits(Bits **);
int GMCalcGraph(Graph *);
long GMPackImage(void *, void *, long);
long GMUnpackImage(void *, void *, long);
LPoint GMAdjustPt(LPoint, Rect *);
int GMPutImg(BitImg *, Rect *);
int GMCenterRect(Rect *, Rect *, LPoint, int);
int GMScrewRect(Rect *);
int GMAndRectRgn(Region **, Region **, Rect *);
int GMOrRectRgn(Region **, Region **, Rect *);
int GMDiffRectRgn(Region **, Region **, Rect *);
int GMXorRectRgn(Region **, Region **, Rect *);
int GMCharKind(int);
int GMDiffRgnRect(Region **, Rect *, Region **);
int (**GMGetHProcTbl(void))();
int (**GMGetStdProcTbl(void))();
int (**GMGetFontProcTbl(void))();
void (**GMGetRgnProcTbl(void))();
int GMDrawGsOne(GSOneEnv *);
int GMPtInImg(RectImg *, LPoint, int);
int GMFrameNPoly(NPoly *, NPolyEnv *);
int GMFillNPoly(NPoly *, NPolyEnv *);
Region **GMNPolyFrRgn(Region **, NPoly *, NPolyEnv *, Rect *);
Region **GMNPolyFlRgn(Region **, NPoly *, NPolyEnv *, Rect *);
BOOLEAN GMPtInNPoly(NPoly *, NPolyEnv *, LPoint);
BOOLEAN GMPtOnNPoly(NPoly *, NPolyEnv *, LPoint);
int GMRecordScript(_Handle, long, long);
int GMNLineRel(LPoint, NPolyEnv *);
int GMNLine(LPoint, NPolyEnv *);
int GMRecordPoly(LPoint);
int GMSetFlattness(int);
int GMGetFlattness(void);
int GMDrawBezier(LPoint, LPoint, LPoint);
int GMDrawBSpline(LPoint, LPoint);
int GMSplitBezier(LPoint, LPoint, LPoint, long, SpltBz *);
int GMSplitBSpline(LPoint, LPoint, long, SpltBSp *);
long GMPtOnBezier(LPoint, LPoint, LPoint, LPoint);
long GMPtOnBSpline(LPoint, LPoint, LPoint);
int GMSetGSDraw(int, int (*)());
int (*GMGetGSDraw(int))();
int GMSetGSGet(int, int (*)());
int (*GMGetGSGet(int))();
/*
 *	tHg} (Font Man)
 */
int FMInit(void);
FontList *FMGetFontList(void);
int FMSetCacheSize(int);
int FMGetCacheSize(void);
int FMSetSpaceWidth(int);
int FMGetSpaceWidth(void);
int FMSetTracking(int);
int FMGetTracking(void);
int FMGetKerningWidth(int, int);
int FMFontMenuSelect(LPoint);
NPoly *FMGetFontPolyData(int);

#undef __PROTO_TYPE
#else
/*
 *	Ot}iGraph Manj
 */
int GMOpenGraph();
int GMCloseGraph();
int GMInitGraph();
int GMSetGraph();
Graph *GMGetGraph();
int GMCopyGraph();
void GMMoveGraph();
void GMSlideGraph();
int GMSetClip();
int GMGetClip();
int GMClipRect();
int GMSetHome();
int GMSetGraphSize();
int GMSetBitmap();
LPoint GMLocalToGlobal();
LPoint GMGlobalToLocal();
void GMInitPen();
BOOLEAN GMPenShow();
BOOLEAN GMPenHide();
LPoint GMPenSize();
int GMPenMode();
BitImg *GMPenPat();
BitImg *GMExPat();
int GMForeColor();
int GMBackColor();
int GMAPage();
LPoint GMGetLoc();
void GMGetPen();
void GMSetPen();
void GMInitialize();
void GMNullRect();
int GMSizeRect();
int GMAndRects();
int GMMoveRect();
int GMSlideRect();
int GMInsetRect();
int GMAndRect();
int GMOrRect();
BOOLEAN GMPtInRect();
BOOLEAN GMEqualRect();
BOOLEAN GMEmptyRect();
int GMAdjustRect();
Region **GMNewRgn();
int GMDisposeRgn();
int GMOpenRgn();
int GMCloseRgn();
int GMNullRgn();
int GMRectRgn();
int GMCopyRgn();
int GMMoveRgn();
int GMSlideRgn();
int GMInsetRgn();
int GMAndRgn();
int GMOrRgn();
int GMDiffRgn();
int GMXorRgn();
int GMPtInRgn();
int GMRectInRgn();
int GMEqualRgn();
int GMEmptyRgn();
int GMImgToRgn();
int GMInitBitmap();
void GMMove();
void GMMoveRel();
int GMLine();
int GMLineRel();
int GMFrameRect();
int GMFillRect();
int GMFrameOval();
int GMFillOval();
int GMFrameRRect();
int GMFillRRect();
int GMFrameArc();
int GMFillArc();
int GMFrameRgn();
int GMFillRgn();
int GMFramePoly();
int GMFillPoly();
int GMScroll();
int GMCopy();
int GMCopyMask();
int GMPlotImg();
int GMPutRImg();
int GMDupHImg();
int GMDupVImg();
int GMDupHRImg();
int GMDupVRImg();
int GMFontKind();
int GMFontFace();
int GMFontMode();
LPoint GMFontSize();
int GMDrawChar();
int GMDrawStrL();
int GMDrawStr();
int GMDrawStrZ();
long GMCharWidth();
long GMStrLWidth();
long GMStrWidth();
int GMStrLength();
LPoint GMFontInfo();
int GMOpenScript();
int GMCloseScript();
int GMDisposeScript();
int GMDrawScript();
long GMGetScript();
int GMOpenPoly();
int GMClosePoly();
int GMDisposePoly();
int GMShadowStrZ();
int GMShadowRect();
int GMInvertRect();
int GMInvertBits();
LPoint GMMapPt();
void GMMapRect();
void GMMapPoly();
void GMMapRgn();
LPoint GMScalePt();
void GMInitPalet();
void GMDrawG16();
int GMGetPixel();
int GMCalcMask();
int GMCalcFrame();
void *SXLongMul();
int SXFixRound();
long SXFixMul();
long SXFixDiv();
unsigned char ***GMGetFontTable();
void GMCopyStdProc();
long GMStrZWidth();
int GMTransImg();
int GMFillRImg();
int GMFillImg();
int GMSlidedRgn();
int GMPaintRgn();
int GMSetRgnLine();
int GMGetRgnLine();
int GMInitGraphMode();
int GMCurFont();
LPoint GMGetScrnSize();
Graph *GMExgGraph();
Bitmap *GMExgBitmap();
Bitmap *GMGetBitmap();
int GMCalcBitmap();
long GMCalcScrnSize();
Bits **GMNewBits();
void GMDisposeBits();
int GMLockBits();
int GMUnlockBits();
int GMItalicRect();
int GMItalicRgn();
void GMFreeBits();
int GMCalcGraph();
long GMPackImage();
long GMUnpackImage();
LPoint GMAdjustPt();
int GMPutImg();
int GMCenterRect();
int GMScrewRect();
int GMAndRectRgn();
int GMOrRectRgn();
int GMDiffRectRgn();
int GMXorRectRgn();
int GMCharKind();
int GMDiffRgnRect();
int (**GMGetHProcTbl())();
int (**GMGetStdProcTbl())();
int (**GMGetFontProcTbl())();
void (**GMGetRgnProcTbl())();
int GMDrawGsOne();
int GMPtInImg();
int GMFrameNPoly();
int GMFillNPoly();
Region **GMNPolyFrRgn();
Region **GMNPolyFlRgn();
BOOLEAN GMPtInNPoly();
BOOLEAN GMPtOnNPoly();
int GMRecordScript();
int GMNLineRel();
int GMNLine();
int GMRecordPoly();
int GMSetFlattness();
int GMGetFlattness();
int GMDrawBezier();
int GMDrawBSpline();
int GMSplitBezier();
int GMSplitBSpline();
long GMPtOnBezier();
long GMPtOnBSpline();
int GMSetGSDraw();
int (*GMGetGSDraw())();
int GMSetGSGet();
int (*GMGetGSGet())();
/*
 *	tHg} (Font Man)
 */
int FMInit();
FontList *FMGetFontList();
int FMSetCacheSize();
int FMGetCacheSize();
int FMSetSpaceWidth();
int FMGetSpaceWidth();
int FMSetTracking();
int FMGetTracking();
int FMGetKerningWidth();
int FMFontMenuSelect();
NPoly *FMGetFontPolyData();

#endif __PROTO_TYPE

#endif __SXGRAPH_H
